/*
gcc main.c -nostartfiles -nostdlib -lSDL -lGL -lGLU -o maini
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/gl.h>
#include <SDL/SDL.h>

//end time in ms
#define INTROEND 20000

typedef struct {
	float x[3];
} XYZ;

#define numpoints 25
#define detail 500
#define width 10
#define radius 10

int rotation;
void _start()
{
	SDL_SetVideoMode(640, 480, 0, SDL_OPENGL); /*|SDL_FULLSCREEN);*/

	int startTime = SDL_GetTicks();

	while (SDL_GetTicks()-startTime < INTROEND)
	{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		glFrustum(-1.33,1.33,-1,1,1.5,1000);

		rotation = 10000 + SDL_GetTicks();
		glRotatef(90,0,1,0);
		int i, j, k;
		XYZ cp[4],p[numpoints],dp[numpoints], a, b, c;

		for(i=0; i<detail; i++)
		{
			float progress=(float)i/(float)detail;
			float sini = sin(2*M_PI*progress);
			float cosi = cos(2*M_PI*progress);
			float dt = 1.0 / (numpoints - 1);
			float t, t2, t3;

			for(k=0; k <3; k++)
			{
				cp[k].x[0]=-width;
				cp[k].x[1]=radius*sini;
				cp[k].x[2]=radius*cosi;
			}
			cp[3].x[0]=width+10*cos(0.001*rotation)+5;
			cp[3].x[1]=radius*sini;
			cp[3].x[2]=10*cos(0.001*rotation)+radius*cosi;

			for(k=0, t=0; k < numpoints; k++, t += dt)
			{
				t2 = t * t;
				t3 = t2 * t;

				for(j=0;j <3; j++)
				{
					c.x[j] = 3 * (cp[1].x[j] - cp[0].x[j]);
					b.x[j] = 3 * (cp[2].x[j] - cp[1].x[j]) - c.x[j];
					a.x[j] = cp[3].x[j] - cp[0].x[j] - c.x[j] - b.x[j];
					p[k].x[j] = (a.x[j] * t3) + (b.x[j] * t2) + (c.x[j] * t) + cp[0].x[j];
				}
			}

			/* Draw "flowers" */
			glBegin(GL_LINES);
			for(j=0; j<numpoints; j++)
			{
					float sinNumpoints = (0.5*sin(M_PI*(float)j/(float)numpoints)+0.5);
					float red=sinNumpoints*(sini+1)/2;
					float blue=sinNumpoints*(cosi+1)/2;
					glColor3f(red,0,blue);

					glVertex3fv(p[j].x);
					glEnd();
					glBegin(GL_LINES);
					glVertex3fv(p[j].x);
			}
			glEnd();
			glRotatef(0.0005*rotation,1,0,0);
		}

		SDL_GL_SwapBuffers();
		SDL_Delay(10);

		SDL_Event event;
		SDL_PollEvent(&event);
		if (event.key.keysym.sym == SDLK_ESCAPE)
		{
			break;
		}
	}

	SDL_Quit();
        asm ( \
	        "movl $1,%eax\n" \
		/*"xor %ebx,%ebx\n" \*/
	        "int $128\n" \
        );
}
